#include <clientprefs>
#include <vip_core>
#include <sdktools>
#include <sdkhooks>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo ={
	name 		= 	"[VIP] Pets",
	author 		= 	"Someone",
	version 	= 	"2.3",
	url			= 	"https://hlmod.ru/ | https://discord.gg/UfD3dSa"
};

enum struct PetInfo{
	char 	Model[PLATFORM_MAX_PATH];
	int 	Skin;
	float 	Scale;
	float 	Gravity;
	int 	Color[4];
	
	bool Walkable;

	float Position[3];
	float Rotation[3];
	
	bool 		DefaultSoundsDisabled;
	StringMap 	Sounds;
	StringMap 	SoundsInfos;
	
	//StringMap Animations;
	
	char IdleAnimation[32];
	char RunAnimation[32];
	char FallAnimation[32];
}

enum{
	Animation_None = -1,
	Animation_Idle = 0,
	Animation_Run = 1,
	Animation_Fall = 2
};

enum{
	Sound_Idle,
	Sound_Panic,
	Sound_Fly,
	Sound_Wings
};

enum struct ClientPetInfo{
	char Name[128];
	
	bool 	Enabled;
	int 	Reference;
	int 	Index;
	int 	LastAnimationId;
	
	float SoundCooldown[4];
	
	PetInfo Settings;
}

bool g_bInGame[MAXPLAYERS+1];
ClientPetInfo g_ClientPetInfo[MAXPLAYERS+1];

bool g_bHidePetForEnemyTeam;
Handle g_hCookie;
EngineVersion g_EV;

int m_hOwnerEntity 	= -1;
int m_flModelScale 	= -1;
int m_nSkin 			= -1;
int m_vecAbsVelocity  = -1;
int m_vecMins			= -1;
int m_vecMaxs  		= -1;
int m_vecOrigin  		= -1;
int m_leader  			= -1;

float g_fTeleportDistance;

ArrayList g_hPetsNames;
ArrayList g_hPetsList;
ArrayList g_hHandlesToClear;

#include "vip_pets/functions.sp"
#include "vip_pets/menu.sp"
#include "vip_pets/config.sp"

public void OnPluginStart(){
	g_hPetsNames 		= new ArrayList(ByteCountToCells(128));
	g_hPetsList 		= new ArrayList(sizeof(PetInfo));
	g_hHandlesToClear = new ArrayList();
	
	InitMenu();
	
	m_hOwnerEntity 	=	FindSendPropInfo("CBaseEntity", 	"m_hOwnerEntity");
	m_flModelScale 	=	FindSendPropInfo("CBaseAnimating", 	"m_flModelScale");
	m_nSkin 			=	FindSendPropInfo("CBaseAnimating", 	"m_nSkin");
	m_vecMins 			=	FindSendPropInfo("CBaseEntity", 	"m_vecMins");
	m_vecMaxs 			=	FindSendPropInfo("CBaseEntity", 	"m_vecMaxs");
	m_vecOrigin 		=	FindSendPropInfo("CBaseEntity", 	"m_vecOrigin");
	m_leader 			=	FindSendPropInfo("CChicken", 		"m_leader");
	
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_spawn", Event_PlayerSpawn);
	
	g_EV = GetEngineVersion();
	g_hCookie = RegClientCookie("VIP_Pets", "Pet's name", CookieAccess_Private);
	
	RegConsoleCmd("sm_pets", CMD_PETS);
	RegAdminCmd("sm_reload_vip_pets", CMD_RELOAD_PETS, ADMFLAG_ROOT);

	LoadTranslations("vip_modules.phrases");
	LoadTranslations("vip_core.phrases");

	ParseConfig();
	
	for(int i = MaxClients+1; --i;) if(IsClientInGame(i)){
		OnClientPutInServer(i);
	}

	if(VIP_IsVIPLoaded()){
		VIP_OnVIPLoaded();
	}
	
	AddNormalSoundHook(ChickenSoundHook);
}

Action ChickenSoundHook(int iClients[MAXPLAYERS], int &iNumClients, char sSound[PLATFORM_MAX_PATH],
	  int &iEnt, int &iChannel, float &fVolume, int &iLevel, int &iPitch, int &iFlags,
	  char sEntry[PLATFORM_MAX_PATH], int &iSeed){
	  
	if(strncmp(sEntry, "Chicken", 7) == 0){
		int iClient = GetEntDataEnt2(iEnt, m_hOwnerEntity);
		if(iClient != -1){
			if(g_ClientPetInfo[iClient].Settings.Sounds && g_ClientPetInfo[iClient].Settings.Sounds.GetString(sEntry[8], sSound, sizeof(sSound))){
				
				if(sSound[0] == 0){
					return Plugin_Stop;
				}

				if(g_bHidePetForEnemyTeam){
					VerifySoundListeners(iClient, iClients, iNumClients);
				}
				
				if(iNumClients > 0){
					float fArray[2];
					if(g_ClientPetInfo[iClient].Settings.SoundsInfos && g_ClientPetInfo[iClient].Settings.SoundsInfos.GetArray(sEntry[8], fArray, sizeof(fArray))){
						
						float fTime = GetGameTime();
						int iSoundType = GetSoundTypeFromString(sEntry[8]);
						if(g_ClientPetInfo[iClient].SoundCooldown[iSoundType] > fTime){
							return Plugin_Stop;
						}

						g_ClientPetInfo[iClient].SoundCooldown[iSoundType] = fTime+fArray[1];
						EmitSound(iClients, iNumClients, sSound, iEnt, _, _, _, fArray[0]);
					}else{
						EmitSound(iClients, iNumClients, sSound, iEnt);
					}
				}
			}else if(!g_ClientPetInfo[iClient].Settings.DefaultSoundsDisabled && g_bHidePetForEnemyTeam){
				VerifySoundListeners(iClient, iClients, iNumClients);
				return Plugin_Changed;
			}
			
			return Plugin_Stop;
		}
	}
	return Plugin_Continue;
}

void VerifySoundListeners(int iClient, int iClients[MAXPLAYERS], int &iNumClients){
	int iNewClients[MAXPLAYERS];
	int iCount;
	int iTeam = GetClientTeam(iClient);
	int iAnotherTeam;
	for(int i = 0; i < iNumClients; i++){
		if(iClients[i] == iClient){
			iNewClients[i] = iClients[i];
			iCount++;
			continue;
		}
	
		iAnotherTeam = GetClientTeam(iClients[i]);
		if(iAnotherTeam < 2 || iAnotherTeam == iTeam){
			iNewClients[i] = iClients[i];
			iCount++;
		}
	}
	
	iClients = iClients;
	iNumClients = iCount;
}

public void VIP_OnVIPLoaded(){
	VIP_RegisterFeature("Pets", BOOL, SELECTABLE, OnSelectItem, OnDisplayItem, OnDrawItem);
}

public void OnPluginEnd(){	
	VIP_UnregisterMe();

	for(int i = MaxClients+1; --i;) if(IsClientInGame(i)){
		RemovePet(i);
	}
}

Action CMD_PETS(int iClient, int iArgs){
	if(VIP_IsClientFeatureUse(iClient, "Pets")){
		DisplayMenuIfCan(iClient);
	}else{
		VIP_PrintToChatClient(iClient, "%t", "NO_ACCESS");
	}
	
	return Plugin_Handled;
}

Action CMD_RELOAD_PETS(int iClient, int iArgs){
	if(ParseConfig()){
		ReplyToCommand(iClient, "[VIP Pets] Config reloaded.");
	}
	return Plugin_Handled;
}

public void OnMapStart(){
	ParseConfig();
}

public void OnClientPutInServer(int iClient){
	//g_ClientPetInfo[iClient].Enabled = false;
	g_ClientPetInfo[iClient].Reference = INVALID_ENT_REFERENCE;
	g_bInGame[iClient] = true;
}

public void OnClientDisconnect(int iClient){
	g_bInGame[iClient] = false;
	RemovePet(iClient);
	g_ClientPetInfo[iClient].Enabled = false;
	g_ClientPetInfo[iClient].Name[0] = 0;
}

bool OnSelectItem(int iClient, const char[] sFeatureName){
	return !DisplayMenuIfCan(iClient);
}

bool OnDisplayItem(int iClient, const char[] sFeatureName, char[] sDisplay, int iMaxLength){
	if(g_ClientPetInfo[iClient].Enabled && g_ClientPetInfo[iClient].Name[0]){
		FormatEx(sDisplay, iMaxLength, "%T [%s]", "Pets_Display", iClient, g_ClientPetInfo[iClient].Name);
	}else{
		FormatEx(sDisplay, iMaxLength, "%T", "Pets_Display", iClient);
	}
	
	return true;
}

int OnDrawItem(int iClient, const char[] szFeature, int iStyle){
	return g_hMenu.ItemCount > 0 ? ITEMDRAW_DEFAULT:ITEMDRAW_DISABLED;
}

Action Event_PlayerDeath(Event hEvent, const char[] sName, bool bDontBroadcast){
	RemovePet(GetClientOfUserId(hEvent.GetInt("userid")));
}

Action Event_PlayerSpawn(Event hEvent, const char[] sName, bool bDontBroadcast){
	int iClient = GetClientOfUserId(hEvent.GetInt("userid"));
	if(IsPlayerAlive(iClient)){
		RemovePet(iClient);
		if(g_ClientPetInfo[iClient].Enabled && GetClientTeam(iClient) > 1 && VIP_IsClientFeatureUse(iClient, "Pets")){
			CreatePet(iClient);
		}
	}
}

public void VIP_OnVIPClientRemoved(int iClient, const char[] szReason, int iAdmin){
	if(g_ClientPetInfo[iClient].Enabled && !VIP_IsClientFeatureUse(iClient, "Pets")){
		g_ClientPetInfo[iClient].Enabled = false;
		RemovePet(iClient);
	}
}

/*
public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP){
	RemovePet(iClient);
	if(bIsVIP && iTeam > 1 && g_ClientPetInfo[iClient].Enabled && VIP_IsClientFeatureUse(iClient, "Pets")){
		CreatePet(iClient);
	}
}
*/

public void OnClientCookiesCached(int iClient){
	GetClientCookie(iClient, g_hCookie, g_ClientPetInfo[iClient].Name, sizeof(g_ClientPetInfo[].Name));
	if(g_ClientPetInfo[iClient].Name[0]){
		if(!ChoosePet(iClient, g_ClientPetInfo[iClient].Name)){
			g_ClientPetInfo[iClient].Name[0] = '\0';
			g_ClientPetInfo[iClient].Enabled = false;
		}
	}
}

//static const char g_sAnimationTypeNames[][] = {"Idle", "Run", "Fall"};

public void OnPlayerRunCmdPost(int iClient, int iButtons, int iImpulse, const float fVel[3], const float fAngles[3], int iWeapon, int iSubType, int iCmdnum, int iTickCount, int iSeed, const int iMouse[2]){
	if(	iTickCount % 5 != 0 ||
		!g_ClientPetInfo[iClient].Enabled || 
		g_ClientPetInfo[iClient].Reference == INVALID_ENT_REFERENCE ||
		!g_bInGame[iClient] ||
		!IsPlayerAlive(iClient)
	){
		return;
	}
	
	int iEnt = EntRefToEntIndex(g_ClientPetInfo[iClient].Reference);
	if(iEnt == INVALID_ENT_REFERENCE){
		return;
	}

	if(g_ClientPetInfo[iClient].Settings.Walkable){

		float fEntPos[3], fClientPos[3];
		GetEntDataVector(iEnt, m_vecOrigin, fEntPos);
		GetClientAbsOrigin(iClient, fClientPos);
		
		if(GetVectorDistance(fEntPos, fClientPos) > g_fTeleportDistance && GetEntityFlags(iClient) & FL_ONGROUND){
			fClientPos[2] += 5.0;
			float fAng[3];
			fAng[1] = GetRandomFloat(0.0, 360.0);

			TeleportEntity(iEnt, fClientPos, fAng, NULL_VECTOR);
		}
		
	}else{
		
		float fVec[3], fDist;
		GetEntDataVector(iClient, m_vecAbsVelocity, fVec);

		static float fOldClientAngles[MAXPLAYERS+1][3];
		float fClientAngles[3];
		
		int iExpectedAnimation = Animation_None;
		
		if(fVec[2] <= -50.0 && g_ClientPetInfo[iClient].Settings.FallAnimation[0]){
			iExpectedAnimation = Animation_Fall;
		}
		
		if(iExpectedAnimation != Animation_Fall){
			GetClientAbsAngles(iClient, fClientAngles);
			if(	fClientAngles[0] != fOldClientAngles[iClient][0] ||
				fClientAngles[1] != fOldClientAngles[iClient][1] ||
				fClientAngles[2] != fOldClientAngles[iClient][2]
			){
				if(g_ClientPetInfo[iClient].Settings.RunAnimation[0]){
					iExpectedAnimation = Animation_Run;
				}
			}else{
				fDist = GetVectorLength(fVec);
				if(fDist > 0.0 && g_ClientPetInfo[iClient].Settings.RunAnimation[0]){
					iExpectedAnimation = Animation_Run;
				}else if(fDist == 0.0 && g_ClientPetInfo[iClient].Settings.IdleAnimation[0]){
					iExpectedAnimation = Animation_Idle;
				}
			}
		}
		
		fOldClientAngles[iClient][0] = fClientAngles[0];
		fOldClientAngles[iClient][1] = fClientAngles[1];
		fOldClientAngles[iClient][2] = fClientAngles[2];

		// Someday...
		if(iExpectedAnimation > Animation_None && g_ClientPetInfo[iClient].LastAnimationId != iExpectedAnimation){
			switch(iExpectedAnimation){
				case Animation_Idle:{
					SetVariantString(g_ClientPetInfo[iClient].Settings.IdleAnimation);
				}
				case Animation_Run:{
					SetVariantString(g_ClientPetInfo[iClient].Settings.RunAnimation);
				}
				case Animation_Fall:{
					SetVariantString(g_ClientPetInfo[iClient].Settings.FallAnimation);
				}
			}
			
			AcceptEntityInput(iEnt, "SetAnimation");
			g_ClientPetInfo[iClient].LastAnimationId = iExpectedAnimation;
		}
	}
}