char g_sSoundTypes[][] = {"Idle", "Panic", "Fly", "FlapWings"};

int GetSoundTypeFromString(const char[] sSound){
	for(int i = 0; i < sizeof(g_sSoundTypes); i++) if(strcmp(sSound, g_sSoundTypes[i]) == 0){
		return i;
	}
	return -1;
}

void RemoveCooldown(int iClient){
	for(int i = 0; i < sizeof(g_ClientPetInfo[].SoundCooldown); i++){
		g_ClientPetInfo[iClient].SoundCooldown[i] = 0.0;
	}
}

bool ChoosePet(int iClient, const char[] sPet){
	int iNum;
	if((iNum = g_hPetsNames.FindString(sPet)) == -1){
		return false;
	}
	
	g_hPetsList.GetArray(iNum, g_ClientPetInfo[iClient].Settings, sizeof(PetInfo));
	g_ClientPetInfo[iClient].Enabled = true;
	strcopy(g_ClientPetInfo[iClient].Name, sizeof(g_ClientPetInfo[].Name), sPet);
	
	SetClientCookie(iClient, g_hCookie, sPet);
	
	return true;
}

void CreatePet(int iClient){

	int iEnt;
	if(g_ClientPetInfo[iClient].Settings.Walkable){
		iEnt = CreateEntityByName("chicken");
	}else{
		iEnt = CreateEntityByName("prop_dynamic_override");
		DispatchKeyValue(iEnt, "model", g_ClientPetInfo[iClient].Settings.Model);
	}

	DispatchKeyValue(iEnt, "solid", "0");
	//DispatchKeyValue(iEnt, "scale", "0");
	DispatchSpawn(iEnt);
	
	SetEntityRenderMode(iEnt, RENDER_TRANSCOLOR);
	SetEntityRenderColor(iEnt, 	g_ClientPetInfo[iClient].Settings.Color[0], 
								g_ClientPetInfo[iClient].Settings.Color[1], 
								g_ClientPetInfo[iClient].Settings.Color[2], 
								g_ClientPetInfo[iClient].Settings.Color[3]);
	
	SetEntDataEnt2(iEnt, m_hOwnerEntity, iClient);
	
	if(m_vecAbsVelocity == -1){
		m_vecAbsVelocity = FindDataMapInfo(iEnt, "m_vecAbsVelocity");
	}
	
	if(g_EV != Engine_SourceSDK2006){
		SetEntDataFloat(iEnt, m_flModelScale, g_ClientPetInfo[iClient].Settings.Scale);
	}
	
	if(g_ClientPetInfo[iClient].Settings.Walkable && g_EV == Engine_CSGO){
		RemoveCooldown(iClient);
		
		SetEntityModel(iEnt, g_ClientPetInfo[iClient].Settings.Model);
		SetEntDataEnt2(iEnt, m_leader, iClient);

		float fVecs[3];
		SetEntDataVector(iEnt, m_vecMins, fVecs);
		fVecs[2] = 32.0;
		SetEntDataVector(iEnt, m_vecMaxs, fVecs);

		SetEntityGravity(iEnt, g_ClientPetInfo[iClient].Settings.Gravity);
		
		float fClientPos[3];
		GetClientAbsOrigin(iClient, fClientPos);
		fClientPos[2] += 5.0;
		TeleportEntity(iEnt, fClientPos, NULL_VECTOR, NULL_VECTOR);
	}else{
		float fClientAng[3], fForward[3], fRight[3], fUp[3];
		GetClientAbsAngles(iClient, fClientAng);
		GetAngleVectors(fClientAng, fForward, fRight, fUp);
		
		fClientAng[0] = g_ClientPetInfo[iClient].Settings.Rotation[0];
		fClientAng[1] += g_ClientPetInfo[iClient].Settings.Rotation[1];
		fClientAng[2] = g_ClientPetInfo[iClient].Settings.Rotation[2];
		
		float fClientPos[3];
		GetClientAbsOrigin(iClient, fClientPos);

		fClientPos[0] += fRight[0]*g_ClientPetInfo[iClient].Settings.Position[0]+fForward[0]*g_ClientPetInfo[iClient].Settings.Position[1]+fUp[0]*g_ClientPetInfo[iClient].Settings.Position[2];
		fClientPos[1] += fRight[1]*g_ClientPetInfo[iClient].Settings.Position[0]+fForward[1]*g_ClientPetInfo[iClient].Settings.Position[1]+fUp[1]*g_ClientPetInfo[iClient].Settings.Position[2];
		fClientPos[2] += fRight[2]*g_ClientPetInfo[iClient].Settings.Position[0]+fForward[2]*g_ClientPetInfo[iClient].Settings.Position[1]+fUp[2]*g_ClientPetInfo[iClient].Settings.Position[2];
		
		AcceptEntityInput(iEnt, "TurnOn", iEnt, iEnt);
		
		TeleportEntity(iEnt, fClientPos, fClientAng, NULL_VECTOR);

		SetVariantString("!activator");
		AcceptEntityInput(iEnt, "SetParent", iClient, iEnt);
	}

	if(g_bHidePetForEnemyTeam){
		SDKHook(iEnt, SDKHook_SetTransmit, OnSetTransmit);
	}

	g_ClientPetInfo[iClient].Reference = EntIndexToEntRef(iEnt);
	g_ClientPetInfo[iClient].Index = iEnt;
	g_ClientPetInfo[iClient].LastAnimationId = -1;
	
	
	SDKHook(iEnt, SDKHook_SpawnPost, OnEntitySpawnPost);
	
	g_ClientPetInfo[iClient].LastAnimationId = Animation_None;
	//RequestFrame(FrameSkin, GetClientUserId(iClient));
}

void OnEntitySpawnPost(int iEnt){
	for(int i = MaxClients+1; --i;) if(g_ClientPetInfo[i].Index == iEnt){
		SetEntData(iEnt, m_nSkin, g_ClientPetInfo[i].Settings.Skin, _, true);
		break;
	}
}

/*
void FrameSkin(int iClient){
	iClient = GetClientOfUserId(iClient);
	if(iClient){
		int iEnt = EntRefToEntIndex(g_ClientPetInfo[iClient].Reference);
		if(iEnt != INVALID_ENT_REFERENCE){
			SetEntData(iEnt, m_nSkin, g_ClientPetInfo[iClient].Settings.Skin);
		}
	}
}
*/

void RemovePet(int iClient){
	if(g_ClientPetInfo[iClient].Reference == INVALID_ENT_REFERENCE){
		return;
	}

	int iEnt = EntRefToEntIndex(g_ClientPetInfo[iClient].Reference);
	g_ClientPetInfo[iClient].Reference = INVALID_ENT_REFERENCE;
	g_ClientPetInfo[iClient].Index = INVALID_ENT_REFERENCE;
	
	if(iEnt == INVALID_ENT_REFERENCE){
		return;
	}

	AcceptEntityInput(iEnt, "Kill");
}

Action OnSetTransmit(int iEnt, int iClient){
	static int iTeam;
	if((iTeam = GetClientTeam(iClient)) > 1 && iTeam != GetClientTeam(GetEntDataEnt2(iEnt, m_hOwnerEntity))){
		return Plugin_Handled;
	}
	return Plugin_Continue;  
}